#if INTERACTIVE
#r "path/IP2Location.dll"
#endif

open IP2Location

//Set Database Path For IPv4 BIN file or IPv4 + IPv6 BIN file (only if you need to query IPv6 IP addresses) and license file
let oIP2Location = new IP2Location.Component(IPDatabasePath = "path/IP2LOCATION-LITE-DB1.BIN", 
                                   IPLicensePath = "path/license.key");
//let oIP2Location = new IP2Location.Component(IPDatabasePath = "path/IP2LOCATION-LITE-DB1.IPV6.BIN", 
//                                   IPLicensePath = "path/license.key");

//Assign IP address for test
let oIPResult = oIP2Location.IPQuery("8.8.8.8");

match oIPResult.Status with
    | "OK"
        ->  System.Console.WriteLine("City: " + oIPResult.City);
            System.Console.WriteLine("Country Code: " + oIPResult.CountryShort);
            System.Console.WriteLine("Country Name: " + oIPResult.CountryLong);
            System.Console.WriteLine("Postal Code: " + oIPResult.ZipCode);
            System.Console.WriteLine("Domain Name: " + oIPResult.DomainName);
            System.Console.WriteLine("ISP Name: " + oIPResult.InternetServiceProvider);
            System.Console.WriteLine("Latitude: " + oIPResult.Latitude.ToString());
            System.Console.WriteLine("Longitude: " + oIPResult.Longitude.ToString());
            System.Console.WriteLine("Region: " + oIPResult.Region);
            System.Console.WriteLine("Time Zone: " + oIPResult.TimeZone);
            System.Console.WriteLine("Net Speed: " + oIPResult.NetSpeed);
            System.Console.WriteLine("IDD Code: " + oIPResult.IDDCode);
            System.Console.WriteLine("Area Code: " + oIPResult.AreaCode);
            System.Console.WriteLine("Weather Station Code: " + oIPResult.WeatherStationCode);
            System.Console.WriteLine("Weather Station Name: " + oIPResult.WeatherStationName);
            System.Console.WriteLine("MCC: " + oIPResult.MCC);
            System.Console.WriteLine("MNC: " + oIPResult.MNC);
            System.Console.WriteLine("Mobile Brand: " + oIPResult.MobileBrand);
            System.Console.WriteLine("Elevation: " + oIPResult.Elevation.ToString());
            System.Console.WriteLine("Usage Type: " + oIPResult.UsageType);
    | "EMPTY_IP_ADDRESS"
        -> System.Console.WriteLine("IP Address cannot be blank.");
    | "INVALID_IP_ADDRESS"
        -> System.Console.WriteLine("Invalid IP Address.");
    | "MISSING_FILE"
        -> System.Console.WriteLine("Invalid Database Path.");
    | _ 
        -> System.Console.WriteLine("NOK");

