﻿//--------------------------------------------------------------------------
// Title        : Sample code for IP2Location DotNet Component
// Description  : This script lookup the country from an IP address.
//                Things that we can do with this script.
//               		1. Redirect based on country 
//                		2. Digital rights management 
//               		3. Web log stats and analysis 
//                		4. Auto-selection of country on forms 
//                		5. Filter access from countries you do not do business with 
//                		6. Geo-targeting for increased sales and click-thrus 
//                		7. And much, much more! 
// Requirements : Microsoft .NET 4.0 framework
//
// Author       : IP2Location.com
// URL          : http://www.ip2location.com
// Email        : sales@ip2location.com
//
// Copyright (c) 2002-2014 IP2Location.com
//---------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace IP2LocationComponentClientAspCSharp
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        override protected void OnInit(EventArgs e)
        {
            InitializeComponent();
            base.OnInit(e);
        }

        private void InitializeComponent()
        {
            this.btnQuery.Click += new System.EventHandler(this.btnQuery_Click);
            this.Load += new System.EventHandler(this.Page_Load);
        }

        private void btnQuery_Click(object sender, System.EventArgs e)
        {
            this.txtIPResult.Text = "";
            this.Query(this.txtIPAddress.Text);
        }

        private void Query(string strIPAddress)
        {
            IP2Location.IPResult oIPResult = new IP2Location.IPResult();
            IP2Location.Component oIP2Location = new IP2Location.Component();
            try
            {
                if (strIPAddress != "")
                {
                    oIP2Location.IPDatabasePath = @"C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.BIN"; // for just IPv4
                    // oIP2Location.IPDatabasePath = @"C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.IPV6.BIN"; // for both IPv4 & IPv6

                    //Set License Path
                    oIP2Location.IPLicensePath = @"C:\Program Files\IP2Location\License.key";
                    oIPResult = oIP2Location.IPQuery(strIPAddress);
                    switch (oIPResult.Status.ToString())
                    {
                        case "OK":
                            this.txtIPResult.Text += "IP Address: " + oIPResult.IPAddress + "\n";
                            this.txtIPResult.Text += "City: " + oIPResult.City + "\n";
                            this.txtIPResult.Text += "Country Code: " + oIPResult.CountryShort + "\n";
                            this.txtIPResult.Text += "Country Name: " + oIPResult.CountryLong + "\n";
                            this.txtIPResult.Text += "Postal Code: " + oIPResult.ZipCode + "\n";
                            this.txtIPResult.Text += "Domain Name: " + oIPResult.DomainName + "\n";
                            this.txtIPResult.Text += "ISP Name: " + oIPResult.InternetServiceProvider + "\n";
                            this.txtIPResult.Text += "Latitude: " + oIPResult.Latitude + "\n";
                            this.txtIPResult.Text += "Longitude: " + oIPResult.Longitude + "\n";
                            this.txtIPResult.Text += "Region: " + oIPResult.Region + "\n";
                            this.txtIPResult.Text += "Time Zone: " + oIPResult.TimeZone + "\n";
                            this.txtIPResult.Text += "Net Speed: " + oIPResult.NetSpeed + "\n";
                            this.txtIPResult.Text += "IDD Code: " + oIPResult.IDDCode + "\n";
                            this.txtIPResult.Text += "Area Code: " + oIPResult.AreaCode + "\n";
                            this.txtIPResult.Text += "Weather Station Code: " + oIPResult.WeatherStationCode + "\n";
                            this.txtIPResult.Text += "Weather Station Name: " + oIPResult.WeatherStationName + "\n";
                            this.txtIPResult.Text += "MCC: " + oIPResult.MCC + "\n";
                            this.txtIPResult.Text += "MNC: " + oIPResult.MNC + "\n";
                            this.txtIPResult.Text += "Mobile Brand: " + oIPResult.MobileBrand + "\n";
                            this.txtIPResult.Text += "Elevation: " + oIPResult.Elevation + "\n";
                            this.txtIPResult.Text += "Usage Type: " + oIPResult.UsageType + "\n";
                            break;
                        case "EMPTY_IP_ADDRESS":
                            Response.Write("IP Address cannot be blank.");
                            break;
                        case "INVALID_IP_ADDRESS":
                            Response.Write("Invalid IP Address.");
                            break;
                        case "MISSING_FILE":
                            Response.Write("Invalid Database Path.");
                            break;
                    }
                }
                else
                {
                    Response.Write("IP Address cannot be blank.");
                }
            }
            catch (Exception ex)
            {
                Response.Write(ex.Message);
            }
            finally
            {
                oIPResult = null;
                oIP2Location = null;
            }
        }
    }
}
