﻿'--------------------------------------------------------------------------
' Title        : Sample code for IP2Location DotNet Component
' Description  : This script lookup the country from an IP address.
'                Things that we can do with this script.
'               		1. Redirect based on country 
'                		2. Digital rights management 
'               		3. Web log stats and analysis 
'                		4. Auto-selection of country on forms 
'                		5. Filter access from countries you do not do business with 
'                		6. Geo-targeting for increased sales and click-thrus 
'                		7. And much, much more! 
' Requirements : Microsoft .NET 4.0
'
' Author       : IP2Location.com
' URL          : http://www.ip2location.com
' Email        : sales@ip2location.com
'
' Copyright (c) 2002-2014 IP2Location.com
'---------------------------------------------------------------------------

Public Class _Default
    Inherits System.Web.UI.Page

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Private Sub btnQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuery.Click
        Me.txtIPResult.Text = ""
        Me.Query(Me.txtIPAddress.Text)
    End Sub
    Private Sub Query(ByVal strIPAddress As String)
        Dim oIPResult As New IP2Location.IPResult
        Dim oIP2Location As New IP2Location.Component
        Try
            If strIPAddress <> "" Then
                oIP2Location.IPDatabasePath = "C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.BIN" ' only IPv4
                'oIP2Location.IPDatabasePath = "C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.IPV6.BIN" ' IPv4 & IPv6

                'Set License Path
                oIP2Location.IPLicensePath = "C:\Program Files\IP2Location\License.key"

                oIPResult = oIP2Location.IPQuery(strIPAddress)
                Select Case oIPResult.Status
                    Case "OK"
                        Me.txtIPResult.Text += "IP Address: " & oIPResult.IPAddress & vbNewLine
                        Me.txtIPResult.Text += "City: " & oIPResult.City & vbNewLine
                        Me.txtIPResult.Text += "Country Code: " & oIPResult.CountryShort & vbNewLine
                        Me.txtIPResult.Text += "Country Name: " & oIPResult.CountryLong & vbNewLine
                        Me.txtIPResult.Text += "Postal Code: " & oIPResult.ZipCode & vbNewLine
                        Me.txtIPResult.Text += "Domain Name: " & oIPResult.DomainName & vbNewLine
                        Me.txtIPResult.Text += "ISP Name: " & oIPResult.InternetServiceProvider & vbNewLine
                        Me.txtIPResult.Text += "Latitude: " & oIPResult.Latitude & vbNewLine
                        Me.txtIPResult.Text += "Longitude: " & oIPResult.Longitude & vbNewLine
                        Me.txtIPResult.Text += "Region: " & oIPResult.Region & vbNewLine
                        Me.txtIPResult.Text += "Time Zone: " & oIPResult.TimeZone & vbNewLine
                        Me.txtIPResult.Text += "Net Speed: " & oIPResult.NetSpeed & vbNewLine
                        Me.txtIPResult.Text += "IDD Code: " & oIPResult.IDDCode & vbNewLine
                        Me.txtIPResult.Text += "Area Code: " & oIPResult.AreaCode & vbNewLine
                        Me.txtIPResult.Text += "Weather Station Code: " & oIPResult.WeatherStationCode & vbNewLine
                        Me.txtIPResult.Text += "Weather Station Name: " & oIPResult.WeatherStationName & vbNewLine
                        Me.txtIPResult.Text += "MCC: " & oIPResult.MCC & vbNewLine
                        Me.txtIPResult.Text += "MNC: " & oIPResult.MNC & vbNewLine
                        Me.txtIPResult.Text += "Mobile Brand: " & oIPResult.MobileBrand & vbNewLine
                        Me.txtIPResult.Text += "Elevation: " & oIPResult.Elevation & vbNewLine
                        Me.txtIPResult.Text += "Usage Type: " & oIPResult.UsageType & vbNewLine
                    Case "EMPTY_IP_ADDRESS"
                        Response.Write("IP Address cannot be blank.")
                    Case "INVALID_IP_ADDRESS"
                        Response.Write("Invalid IP Address.")
                    Case "MISSING_FILE"
                        Response.Write("Invalid Database Path.")
                End Select
            Else
                Response.Write("IP Address cannot be blank.")
            End If
        Catch ex As Exception
            Response.Write(ex.Message)
        Finally
            oIPResult = Nothing
            oIP2Location = Nothing
        End Try
    End Sub

End Class