//--------------------------------------------------------------------------
// Title        : Sample code for IP2Location DotNet Component
// Description  : This script lookup the country from an IP address.
//                Things that we can do with this script.
//                		1. Redirect based on country 
//                		2. Digital rights management 
//                		3. Web log stats and analysis 
//                		4. Auto-selection of country on forms 
//                		5. Filter access from countries you do not do business with 
//                		6. Geo-targeting for increased sales and click-thrus 
//               		7. And much, much more! 
// Requirements : Microsoft .NET 4.0
//
// Author       : IP2Location.com
// URL          : http://www.ip2location.com
// Email        : sales@ip2location.com
//
// Copyright (c) 2002-2014 IP2Location.com
//---------------------------------------------------------------------------
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace IP2LocationComponentCSharp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.TextBox txtIPResult;
		internal System.Windows.Forms.TextBox txtIPAddress;
		internal System.Windows.Forms.Button btnQuery;
		internal System.Windows.Forms.Label lblIPAddress;
		private System.Windows.Forms.LinkLabel hplIP2Location;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtIPResult = new System.Windows.Forms.TextBox();
			this.txtIPAddress = new System.Windows.Forms.TextBox();
			this.btnQuery = new System.Windows.Forms.Button();
			this.lblIPAddress = new System.Windows.Forms.Label();
			this.hplIP2Location = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// txtIPResult
			// 
			this.txtIPResult.Location = new System.Drawing.Point(8, 40);
			this.txtIPResult.Multiline = true;
			this.txtIPResult.Name = "txtIPResult";
			this.txtIPResult.Size = new System.Drawing.Size(336, 352);
			this.txtIPResult.TabIndex = 8;
			this.txtIPResult.Text = "";
			// 
			// txtIPAddress
			// 
			this.txtIPAddress.Location = new System.Drawing.Point(144, 8);
			this.txtIPAddress.Name = "txtIPAddress";
			this.txtIPAddress.TabIndex = 7;
			this.txtIPAddress.Text = "";
			// 
			// btnQuery
			// 
			this.btnQuery.Location = new System.Drawing.Point(248, 8);
			this.btnQuery.Name = "btnQuery";
			this.btnQuery.TabIndex = 6;
			this.btnQuery.Text = "Query";
			this.btnQuery.Click += new System.EventHandler(this.btnQuery_Click);
			// 
			// lblIPAddress
			// 
			this.lblIPAddress.Location = new System.Drawing.Point(8, 8);
			this.lblIPAddress.Name = "lblIPAddress";
			this.lblIPAddress.Size = new System.Drawing.Size(144, 23);
			this.lblIPAddress.TabIndex = 5;
			this.lblIPAddress.Text = "IP Address/Domain Name:";
			// 
			// hplIP2Location
			// 
			this.hplIP2Location.Location = new System.Drawing.Point(8, 408);
			this.hplIP2Location.Name = "hplIP2Location";
			this.hplIP2Location.Size = new System.Drawing.Size(248, 23);
			this.hplIP2Location.TabIndex = 9;
			this.hplIP2Location.TabStop = true;
			this.hplIP2Location.Text = "http://www.ip2location.com";
			this.hplIP2Location.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.hplIP2Location_LinkClicked);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(352, 438);
			this.Controls.Add(this.hplIP2Location);
			this.Controls.Add(this.txtIPResult);
			this.Controls.Add(this.txtIPAddress);
			this.Controls.Add(this.btnQuery);
			this.Controls.Add(this.lblIPAddress);
			this.Name = "frmMain";
			this.Text = "IP2Location Component C# Sample Code";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void btnQuery_Click(object sender, System.EventArgs e)
		{
			this.txtIPResult.Text = "";
			this.Query(this.txtIPAddress.Text);
		}
		private void Query(string strIPAddress)
		{
			IP2Location.IPResult oIPResult = new IP2Location.IPResult();
			IP2Location.Component oIP2Location = new IP2Location.Component();
			try
			{
				
				if (strIPAddress != "")
				{
                    oIP2Location.IPDatabasePath = @"C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.BIN"; // only IPv4
                    // oIP2Location.IPDatabasePath = @"C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.IPV6.BIN"; // IPv4 & IPv6

                    //Set License Path
                    oIP2Location.IPLicensePath = @"C:\Program Files\IP2Location\License.key";

                    oIPResult = oIP2Location.IPQuery(strIPAddress);
					switch(oIPResult.Status.ToString())
					{
						case "OK":
							this.txtIPResult.AppendText("IP Address: " + oIPResult.IPAddress + "\n");
							this.txtIPResult.AppendText("City: " + oIPResult.City + "\n");
							this.txtIPResult.AppendText("Country Code: " + oIPResult.CountryShort + "\n");
							this.txtIPResult.AppendText("Country Name: " + oIPResult.CountryLong + "\n");
							this.txtIPResult.AppendText("Postal Code: " + oIPResult.ZipCode + "\n");
							this.txtIPResult.AppendText("Domain Name: " + oIPResult.DomainName + "\n");
							this.txtIPResult.AppendText("ISP Name: " + oIPResult.InternetServiceProvider + "\n");
							this.txtIPResult.AppendText("Latitude: " + oIPResult.Latitude + "\n");
							this.txtIPResult.AppendText("Longitude: " + oIPResult.Longitude + "\n");
							this.txtIPResult.AppendText("Region: " + oIPResult.Region + "\n");
							this.txtIPResult.AppendText("Time Zone: " + oIPResult.TimeZone + "\n");
							this.txtIPResult.AppendText("Net Speed: " + oIPResult.NetSpeed + "\n");
							this.txtIPResult.AppendText("IDD Code: " + oIPResult.IDDCode + "\n");
							this.txtIPResult.AppendText("Area Code: " + oIPResult.AreaCode + "\n");
							this.txtIPResult.AppendText("Weather Station Code: " + oIPResult.WeatherStationCode + "\n");
							this.txtIPResult.AppendText("Weather Station Name: " + oIPResult.WeatherStationName + "\n");
							this.txtIPResult.AppendText("MCC: " + oIPResult.MCC + "\n");
							this.txtIPResult.AppendText("MNC: " + oIPResult.MNC + "\n");
							this.txtIPResult.AppendText("Mobile Brand: " + oIPResult.MobileBrand + "\n");
							this.txtIPResult.AppendText("Elevation: " + oIPResult.Elevation + "\n");
							this.txtIPResult.AppendText("Usage Type: " + oIPResult.UsageType + "\n");
							break; 
						case "EMPTY_IP_ADDRESS":
							MessageBox.Show("IP Address cannot be blank.");
							break; 
						case "INVALID_IP_ADDRESS":
							MessageBox.Show("Invalid IP Address.");
							break; 
						case "MISSING_FILE":
							MessageBox.Show("Invalid File Path.");
							break;
					}
				}
				else 
				{
					MessageBox.Show("IP Address cannot be blank.");
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			finally
			{
				oIPResult = null;
				oIP2Location = null;
			}
		}

		private void hplIP2Location_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start("http://www.ip2location.com");
		}
	}
}
