'--------------------------------------------------------------------------
' Title        : Sample code for IP2Location DotNet Component
' Description  : This script lookup the country from an IP address.
'                Things that we can do with this script.
'                		1. Redirect based on country 
'                		2. Digital rights management 
'                		3. Web log stats and analysis 
'                		4. Auto-selection of country on forms 
'                		5. Filter access from countries you do not do business with 
'                		6. Geo-targeting for increased sales and click-thrus 
'                		7. And much, much more! 
' Requirements : Microsoft .NET 4.0
'
' Author       : IP2Location.com
' URL          : http://www.ip2location.com
' Email        : sales@ip2location.com
'
' Copyright (c) 2002-2014 IP2Location.com
'---------------------------------------------------------------------------
Imports System.Diagnostics.Process
Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblIPAddress As System.Windows.Forms.Label
    Friend WithEvents btnQuery As System.Windows.Forms.Button
    Friend WithEvents txtIPAddress As System.Windows.Forms.TextBox
    Friend WithEvents txtIPResult As System.Windows.Forms.TextBox
    Friend WithEvents hplIP2Location As System.Windows.Forms.LinkLabel
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lblIPAddress = New System.Windows.Forms.Label
        Me.btnQuery = New System.Windows.Forms.Button
        Me.txtIPAddress = New System.Windows.Forms.TextBox
        Me.txtIPResult = New System.Windows.Forms.TextBox
        Me.hplIP2Location = New System.Windows.Forms.LinkLabel
        Me.SuspendLayout()
        '
        'lblIPAddress
        '
        Me.lblIPAddress.Location = New System.Drawing.Point(8, 8)
        Me.lblIPAddress.Name = "lblIPAddress"
        Me.lblIPAddress.Size = New System.Drawing.Size(144, 23)
        Me.lblIPAddress.TabIndex = 0
        Me.lblIPAddress.Text = "IP Address/Domain Name:"
        '
        'btnQuery
        '
        Me.btnQuery.Location = New System.Drawing.Point(256, 8)
        Me.btnQuery.Name = "btnQuery"
        Me.btnQuery.TabIndex = 2
        Me.btnQuery.Text = "Query"
        '
        'txtIPAddress
        '
        Me.txtIPAddress.Location = New System.Drawing.Point(152, 8)
        Me.txtIPAddress.Name = "txtIPAddress"
        Me.txtIPAddress.TabIndex = 3
        Me.txtIPAddress.Text = ""
        '
        'txtIPResult
        '
        Me.txtIPResult.Location = New System.Drawing.Point(8, 40)
        Me.txtIPResult.Multiline = True
        Me.txtIPResult.Name = "txtIPResult"
        Me.txtIPResult.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIPResult.Size = New System.Drawing.Size(376, 368)
        Me.txtIPResult.TabIndex = 4
        Me.txtIPResult.Text = ""
        '
        'hplIP2Location
        '
        Me.hplIP2Location.Location = New System.Drawing.Point(8, 416)
        Me.hplIP2Location.Name = "hplIP2Location"
        Me.hplIP2Location.Size = New System.Drawing.Size(248, 16)
        Me.hplIP2Location.TabIndex = 5
        Me.hplIP2Location.TabStop = True
        Me.hplIP2Location.Text = "http://www.ip2location.com"
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(392, 438)
        Me.Controls.Add(Me.hplIP2Location)
        Me.Controls.Add(Me.txtIPResult)
        Me.Controls.Add(Me.txtIPAddress)
        Me.Controls.Add(Me.btnQuery)
        Me.Controls.Add(Me.lblIPAddress)
        Me.Name = "frmMain"
        Me.Text = "IP2Location Component Client"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuery.Click
        Me.txtIPResult.Text = ""
        Me.Query(Me.txtIPAddress.Text)
    End Sub

    Private Sub Query(ByVal strIPAddress As String)
        Dim oIPResult As New IP2Location.IPResult
        Dim oIP2Location As New IP2Location.Component
        Try
            If strIPAddress <> "" Then
                oIP2Location.IPDatabasePath = "C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.BIN" ' only IPv4
                'oIP2Location.IPDatabasePath = "C:\Program Files\IP2Location\IP2LOCATION-LITE-DB1.IPV6.BIN" ' IPv4 & IPv6

                'Set License Path
                oIP2Location.IPLicensePath = "C:\Program Files\IP2Location\License.key"

                oIPResult = oIP2Location.IPQuery(strIPAddress)
                Select Case oIPResult.Status
                    Case "OK"
                        Me.txtIPResult.AppendText("IP Address: " & oIPResult.IPAddress & vbNewLine)
                        Me.txtIPResult.AppendText("City: " & oIPResult.City & vbNewLine)
                        Me.txtIPResult.AppendText("Country Code: " & oIPResult.CountryShort & vbNewLine)
                        Me.txtIPResult.AppendText("Country Name: " & oIPResult.CountryLong & vbNewLine)
                        Me.txtIPResult.AppendText("Postal Code: " & oIPResult.ZipCode & vbNewLine)
                        Me.txtIPResult.AppendText("Domain Name: " & oIPResult.DomainName & vbNewLine)
                        Me.txtIPResult.AppendText("ISP Name: " & oIPResult.InternetServiceProvider & vbNewLine)
                        Me.txtIPResult.AppendText("Latitude: " & oIPResult.Latitude & vbNewLine)
                        Me.txtIPResult.AppendText("Longitude: " & oIPResult.Longitude & vbNewLine)
                        Me.txtIPResult.AppendText("Region: " & oIPResult.Region & vbNewLine)
                        Me.txtIPResult.AppendText("TimeZone: " & oIPResult.TimeZone & vbNewLine)
                        Me.txtIPResult.AppendText("NetSpeed: " & oIPResult.NetSpeed & vbNewLine)
                        Me.txtIPResult.AppendText("IDD Code: " & oIPResult.IDDCode & vbNewLine)
                        Me.txtIPResult.AppendText("Area Code: " & oIPResult.AreaCode & vbNewLine)
                        Me.txtIPResult.AppendText("Weather Station Code: " & oIPResult.WeatherStationCode & vbNewLine)
                        Me.txtIPResult.AppendText("Weather Station Name: " & oIPResult.WeatherStationName & vbNewLine)
                        Me.txtIPResult.AppendText("MCC: " & oIPResult.MCC & vbNewLine)
                        Me.txtIPResult.AppendText("MNC: " & oIPResult.MNC & vbNewLine)
                        Me.txtIPResult.AppendText("Mobile Brand: " & oIPResult.MobileBrand & vbNewLine)
                        Me.txtIPResult.AppendText("Elevation: " & oIPResult.Elevation & vbNewLine)
                        Me.txtIPResult.AppendText("Usage Type: " & oIPResult.UsageType & vbNewLine)
                    Case "EMPTY_IP_ADDRESS"
                        MsgBox("IP Address cannot be blank.")
                    Case "INVALID_IP_ADDRESS"
                        MsgBox("Invalid IP Address.")
                    Case "MISSING_FILE"
                        MsgBox("Invalid Database Path.")
                End Select
            Else
                MsgBox("IP Address cannot be blank.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            oIPResult = Nothing
            oIP2Location = Nothing
        End Try
    End Sub

    Private Sub hplIP2Location_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles hplIP2Location.LinkClicked
        Start("http://www.ip2location.com")
    End Sub

End Class